use std::net::TcpStream;
use std::net::TcpListener;
use std::io::prelude::*;
use std::env;
use std::thread;

fn handle_request(mut stream: TcpStream) {
    let mut buffer = [0; 128];
    stream.read(&mut buffer).unwrap();
    println!("Client: {}", stream.peer_addr().unwrap());
    let response = "HTTP/1.1 200 OK\r\n\r\n";
    stream.write(response.as_bytes()).unwrap();
    stream.flush().unwrap();
}

fn main() {
    let args: Vec<String> = env::args().collect();
    if args.len() != 2 {
        println!("Usage: {} [port]", args[0]);
        return;
    }

    let port = ::std::env::args().nth(1).unwrap();
    let ip = "127.0.0.1";
    let my_server = ip.to_string() + ":" + &port;
    let server_details: &str = &my_server;

    let listener = TcpListener::bind(server_details).unwrap();
    println!("Waiting for new connections!");

    for stream in listener.incoming() {
        match stream {
            Err(e) => { println!("Failed: {}", e) }
            Ok(stream) => {
                thread::spawn(move || {
                    handle_request(stream)
                });
            }
        }
    }
}
