use std::net::TcpStream;
use std::io::Write;
use std::io::Read;
use std::env;

fn main() {
    let args: Vec<String> = env::args().collect();
    if args.len() != 3 {
        println!("Usage: {} [server ip] [port]", args[0]);
        return;
    }
    let server = ::std::env::args().nth(1).unwrap();
    let port = ::std::env::args().nth(2).unwrap();
    let my_bind = format!("{}:{}", server, port);
    let my_bind_final: &str = &my_bind;

    let mut buf: [u8; 32] = [0; 32];
    let stream = TcpStream::connect(my_bind_final);
    println!("stream info: {:?}", stream);

	let mut my_stream = stream.unwrap();
    my_stream.write(b"Hi there!\r\n").unwrap();
    let _ = match my_stream.read(&mut buf) {
        Err(e) => panic!("Error: {}", e),
        Ok(m) => {
            if m == 0 {
                println!("Failed to Read!");
            }
			println!("Read: {} chars", m);
            m
        },
    };

    let s = String::from_utf8_lossy(&buf);
    print!("Read: {}", s);
}
