use std::net::{TcpListener, TcpStream};
use std::thread;

use std::io::Read;
use std::io::Write;
use std::env;

fn handle_request(mut stream: TcpStream) {
    let mut buf;
    loop {
        buf = [0; 1024];
        let _ = match stream.read(&mut buf) {
            Err(e) => panic!("Error: {}", e),
            Ok(m) => {
                if m == 0 {
                    break;
                }
            },
        };
        _ = stream.write(&buf);
    }
}

fn main() {
    let args: Vec<String> = env::args().collect();
    if args.len() != 2 {
        println!("Usage: {} [port]", args[0]);
        return;
    }
    let port = ::std::env::args().nth(1).unwrap();
    let ip = "127.0.0.1";
    let my_bind = ip.to_string() + ":" + &port;
    let my_bind_final: &str = &my_bind;
    let listener = TcpListener::bind(my_bind_final).unwrap();
    for stream in listener.incoming() {
        match stream {
            Err(e) => { println!("Failed: {}", e) }
            Ok(stream) => {
                thread::spawn(move || { handle_request(stream) });
            }
        }
    }
}
