#[macro_use]
extern crate serde_derive;

#[allow(unused_imports)]
use serde::{Serialize, Deserialize};

#[derive(Serialize, Deserialize, Debug)]
struct LXF {
    issue: i32,
    year: i32,
}

fn main() {
    let magazine = "{ \"issue\": 288, \"year\": 2022 }";

    // Convert the JSON string to a LXF variable.
    let deserialized: LXF = serde_json::from_str(&magazine).unwrap();
    // Prints deserialized
    println!("deserialized = {:?}", deserialized);

    // Convert the LXF record to a JSON string.
    let serialized = serde_json::to_string(&deserialized).unwrap();
    println!("serialized = {}", serialized);
}
